 SUBROUTINE ERROUT( PRTFIL, Severity, WHERE, ErrMsg )

!     Outputs an error message

!     PRTFIL unit number for print-out
!     Severity:
!        'W' Warning
!        'F' Fatal
!     WHERE  in which program or subroutine
!     ErrMsg error message

 IMPLICIT NONE
 INTEGER   PRTFIL, Last
 CHARACTER (LEN=1), INTENT( IN ) :: Severity
 CHARACTER (LEN=*), INTENT( IN ) :: WHERE, ErrMsg

 WRITE( PRTFIL, * )

 SELECT CASE ( Severity )  !     *** Severity ***
  CASE ( 'W' )
     WRITE( PRTFIL, * ) '*** WARNING ***'
  CASE ( 'F' )
     WRITE( PRTFIL, * ) '*** FATAL ERROR ***'
  CASE DEFAULT
     WRITE( PRTFIL, * ) '*** FATAL ERROR ***'
     WRITE( PRTFIL, * ) 'Error handler (ERROUT) called with unknown severity level: ', Severity
 END SELECT

 Last = LEN( WHERE )
 WRITE( PRTFIL, * ) 'Generated by program or subroutine: ', WHERE( 1 : Last )

 Last = LEN( ErrMsg )
 WRITE( PRTFIL, * ) ErrMsg( 1 : Last )
 WRITE( PRTFIL, * )

! return or stop depending on severity

IF ( Severity == 'W' ) THEN
 RETURN
ELSE
 STOP 'Fatal Error: See print file for details'
ENDIF

END
