% plottests
% runs a battery of test problems for the Acoustics Toolbox

clear all

% general tests

% SPARC
sparcM( 'iso' )
plottsmat iso

% bounce
bounce( 'refl' )
figure
plotbrc( 'refl' )

cases = [ ...
   'free       '; ...
   'halfspace  '; ...
   'calib      '; ...
   'Munk       '; ...
   'sduct      '; ...
   'Dickins    '; ...
   'arctic     '; ...
   'SBCX       '; ...
   'BeamPattern'; ...
   'TabRefCoef '; ...
   'PointLine  '; ...
   'ParaBot    '; ...
   'block      '; ...
   %           'terrain    '; ...
   %           '3DAtlantic '; ...
   %           'wedge      '; ...
   'head       '; ...
   %           'TLslices   '; ...
   ];

 
for icase = 1 : size( cases, 1 )
   directory = deblank( cases( icase, : ) )
   eval( [ 'cd ' directory ] );
   runtestsM
   cd ..
end
